#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TProfile.h"
#include "TF1.h"
#include "TGraph.h"

#include "interface/FuncDef.h"

void Plot()
{

  setTDRStyle();
  gROOT->Reset();

  TFile *f1 = new TFile("Smearing.root","read");
  TTree *Analyze = (TTree*)f1->Get("Analysis");


//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

   TCanvas *c1 = new TCanvas("c1","gerrors2",100,100,600,450);
   c1->cd(); 
  
   const Int_t numBin=5;
//   double bins[numBin]={5,10,25,55,85,115,205,400};
   double bins[5]={10,30,50,80,120};
   TProfile *ETSoverET = new TProfile("ETSoverET","Resolution des electrons",(numBin-1),bins,-10,10);
   Analyze->Draw("JetPTResol.SmearePT:JetPTResol.NonSmearePT>>ETSoverET","JetPTResol.NonSmearePT>1");

   double rms[numBin];
   double mean[numBin];
   //TF1 *Gauss = new TF1("Gauss","gaus",0,4);

   TCanvas *c2 = new TCanvas("c2","gerrors2",0,0,1000,650);
   c2->cd(); int frame=0;
   c2->Divide(6,2);
//   c2->Divide(6,2);

   float x[numBin];
   float y[numBin];
   float finval=0;//valeur a remplir puis a fitter

   for ( int i=0; i<numBin; i++)  // première bin : i ==1 et pas i == 0
      {
        TAxis *xaxis = ETSoverET->GetXaxis();
        float binCenter = xaxis->GetBinCenter(i+1);
        int binMin = (int)xaxis->GetBinLowEdge(i+1);
        int binMax = (int)xaxis->GetBinUpEdge(i+1);
        cout<<"binMin "<<binMin<<" binMax "<<binMax<<" bin center "<<binCenter<<endl;
        char tempMin[500];
        sprintf(tempMin,"JetPTResol.NonSmearePT>%d",binMin);
        string mystringMin(tempMin);
        char tempMax[500];
        sprintf(tempMax,"JetPTResol.NonSmearePT<%d",binMax);
        string mystringMax(tempMax);
        char tempName[500];
        sprintf(tempName,"JetPTResol.SmearePT>>hETSoverET%d",i);
        string mystringName(tempName);

        c2->cd(++frame);
        GaussValues(Analyze,tempName,rms[i],mean[i],mystringMin,mystringMax);
        x[i]=binCenter;
        mean[i]=ETSoverET->GetBinContent(i+1);
   //     rms[i]=ETSoverET->GetBinError(i+1);
        finval=rms[i]/mean[i];
        y[i]=finval;
        cout<<"finval "<<finval<<" mean val "<<mean[i]<<" rms value "<<rms[i]<<endl;

      }

y[0]=0.2;

   TCanvas *c3 = new TCanvas("c3","gerrors2",100,100,600,450);
   c3->cd();

   TF1 *fitfun = new TF1("user","sqrt(pow([0],2)+pow([1]/sqrt(x),2)+pow([2]/x,2))",10,500);

   TGraph *gr11 = new TGraph((numBin),x,y);
   gr11->Draw("AP");
   gr11->GetXaxis()->SetTitle("E_{T}^{MC} [GeV]");
   gr11->GetYaxis()->SetTitle("#sigma(E_{T}^{rec}/E_{T}^{MC})/<E_{T}^{rec}/E_{T}^{MC}>");

   //fitfun->FixParameter(0,0.0541930);
   //fitfun->FixParameter(1,0.634908);
   gr11->Fit("user","RQ");
   gr11->Fit("user","RQ");
   gr11->Fit("user","RQ");
   gr11->Fit("user","R");



 delete fitfun;
// delete Gauss;
}
